#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Baralho */
#include "baralho.h"

/* Graficos. Já inclui headers do Allegro */
#include "grafico.h"

/* Modulos do programa */
#include "ihm.h"
#include "jogo.h"

//-----------------------------------------------------------------------------

int main(int argc, char *argv[])
{
  Window win;
  Baralho cartas;

  MonteImagem *montes; /* Vetor de montes e suas posições.
			  O primeiro elemento contém o deck c/ baralho completo
		       */

  Cabecalho cab;
  char *nomeFile, *buffer, *token, primCard;
  int i;

  /* Indica nome do arquivo com imagem do baralho.
     Para facilitar, nome do arquivo indica as propriedades
     da imagem: "nome-CWxCH-PRIMCARTA-ORDNAIPES.ppm" 
     (e.g., baralho_06-170x256-A-EPCO.ppm)
  */

  if (argc != 2)
  {
     fprintf(stderr, "Indique o arquivo de imagem na linha de comando.\n\n");
     exit(1);
  }

  buffer = strdup(argv[1]);
  nomeFile = strdup(buffer);
  token=strtok(buffer,"-");
  token=strtok(NULL,"-");
  sscanf(token,"%dx%d", &cab.w, &cab.h);
  token=strtok(NULL,"-");
  sscanf(token,"%c", &primCard);
  token=strtok(NULL,"-");
  token=strtok(token,".");

  /* Inicializa baralho */
  cartas = init(nomeFile, cab.w, cab.h, primCard, token);
  cartas = geraBaralho(cartas);

  /* Inicializa Allegro */
  win = graphinit(0,0);
  
  /* Inicializa imagens de montes. */
  montes = iniPosMontes(win, cab);

  /* Inicializa conteúdo de montes. */
  montes = iniMontes(montes, cartas);

  /* Inicia o Jogo */
  jogarJogo(cartas, cab, montes, win);

  /* Após terminar o jogo, destroi todos os bitmaps criados */
  removeImagens(montes, win);

}
